using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using Codeidea.UltraGraphics;

namespace DesignAll
{
	/// <summary>
	/// PageSetup ժҪ˵
	/// </summary>
	public class PageSetupForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.PictureBox pictureBackgroundBitmap;
		private System.Windows.Forms.ComboBox comboBackgroundBitmapMode;
		private System.Windows.Forms.Button btnClear;
		private System.Windows.Forms.Button btnLoad;
		/// <summary>
		/// 
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.NumericUpDown numericSnapPixel;
		private System.Windows.Forms.ComboBox comboUnitType;
		private System.Windows.Forms.Button btnClose;

		public MainForm mainForm;

		public PageSetupForm()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//
		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.btnLoad = new System.Windows.Forms.Button();
			this.btnClear = new System.Windows.Forms.Button();
			this.comboBackgroundBitmapMode = new System.Windows.Forms.ComboBox();
			this.pictureBackgroundBitmap = new System.Windows.Forms.PictureBox();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.comboUnitType = new System.Windows.Forms.ComboBox();
			this.label2 = new System.Windows.Forms.Label();
			this.numericSnapPixel = new System.Windows.Forms.NumericUpDown();
			this.label1 = new System.Windows.Forms.Label();
			this.btnClose = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.numericSnapPixel)).BeginInit();
			this.SuspendLayout();
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.Add(this.btnLoad);
			this.groupBox1.Controls.Add(this.btnClear);
			this.groupBox1.Controls.Add(this.comboBackgroundBitmapMode);
			this.groupBox1.Controls.Add(this.pictureBackgroundBitmap);
			this.groupBox1.Location = new System.Drawing.Point(8, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(272, 88);
			this.groupBox1.TabIndex = 0;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Background bitmap";
			// 
			// btnLoad
			// 
			this.btnLoad.Location = new System.Drawing.Point(184, 56);
			this.btnLoad.Name = "btnLoad";
			this.btnLoad.TabIndex = 3;
			this.btnLoad.Text = "&Load";
			this.btnLoad.Click += new System.EventHandler(this.btnLoad_Click);
			// 
			// btnClear
			// 
			this.btnClear.Location = new System.Drawing.Point(184, 24);
			this.btnClear.Name = "btnClear";
			this.btnClear.TabIndex = 2;
			this.btnClear.Text = "&Clear";
			this.btnClear.Click += new System.EventHandler(this.btnClear_Click);
			// 
			// comboBackgroundBitmapMode
			// 
			this.comboBackgroundBitmapMode.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboBackgroundBitmapMode.Items.AddRange(new object[] {
																		   "Tiled",
																		   "Stretch",
																		   "Center",
																		   "LeftTop"});
			this.comboBackgroundBitmapMode.Location = new System.Drawing.Point(88, 48);
			this.comboBackgroundBitmapMode.Name = "comboBackgroundBitmapMode";
			this.comboBackgroundBitmapMode.Size = new System.Drawing.Size(88, 23);
			this.comboBackgroundBitmapMode.TabIndex = 1;
			this.comboBackgroundBitmapMode.SelectedIndexChanged += new System.EventHandler(this.comboBackgroundBitmapMode_SelectedIndexChanged);
			// 
			// pictureBackgroundBitmap
			// 
			this.pictureBackgroundBitmap.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.pictureBackgroundBitmap.Location = new System.Drawing.Point(16, 24);
			this.pictureBackgroundBitmap.Name = "pictureBackgroundBitmap";
			this.pictureBackgroundBitmap.Size = new System.Drawing.Size(56, 50);
			this.pictureBackgroundBitmap.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.pictureBackgroundBitmap.TabIndex = 0;
			this.pictureBackgroundBitmap.TabStop = false;
			this.pictureBackgroundBitmap.Click += new System.EventHandler(this.pictureBackgroundBitmap_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.Add(this.comboUnitType);
			this.groupBox2.Controls.Add(this.label2);
			this.groupBox2.Controls.Add(this.numericSnapPixel);
			this.groupBox2.Controls.Add(this.label1);
			this.groupBox2.Location = new System.Drawing.Point(8, 104);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(272, 88);
			this.groupBox2.TabIndex = 1;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Other options";
			// 
			// comboUnitType
			// 
			this.comboUnitType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.comboUnitType.Items.AddRange(new object[] {
															   "Pixel",
															   "Millimeter",
															   "Centimeter",
															   "Decimeter",
															   "Meter",
															   "Inch"});
			this.comboUnitType.Location = new System.Drawing.Point(96, 56);
			this.comboUnitType.Name = "comboUnitType";
			this.comboUnitType.Size = new System.Drawing.Size(88, 23);
			this.comboUnitType.TabIndex = 3;
			this.comboUnitType.SelectedIndexChanged += new System.EventHandler(this.comboUnitType_SelectedIndexChanged);
			// 
			// label2
			// 
			this.label2.AutoSize = true;
			this.label2.Location = new System.Drawing.Point(16, 64);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(53, 17);
			this.label2.TabIndex = 2;
			this.label2.Text = "Unit type";
			// 
			// numericSnapPixel
			// 
			this.numericSnapPixel.Location = new System.Drawing.Point(96, 24);
			this.numericSnapPixel.Maximum = new System.Decimal(new int[] {
																			 255,
																			 0,
																			 0,
																			 0});
			this.numericSnapPixel.Name = "numericSnapPixel";
			this.numericSnapPixel.Size = new System.Drawing.Size(88, 21);
			this.numericSnapPixel.TabIndex = 1;
			this.numericSnapPixel.ValueChanged += new System.EventHandler(this.numericSnapPixel_ValueChanged);
			// 
			// label1
			// 
			this.label1.AutoSize = true;
			this.label1.Location = new System.Drawing.Point(16, 32);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(68, 17);
			this.label1.TabIndex = 0;
			this.label1.Text = "Snap pixels";
			// 
			// btnClose
			// 
			this.btnClose.CausesValidation = false;
			this.btnClose.Location = new System.Drawing.Point(200, 208);
			this.btnClose.Name = "btnClose";
			this.btnClose.TabIndex = 0;
			this.btnClose.Text = "&Close";
			this.btnClose.Click += new System.EventHandler(this.btnClose_Click);
			// 
			// PageSetupForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(292, 242);
			this.Controls.Add(this.btnClose);
			this.Controls.Add(this.groupBox2);
			this.Controls.Add(this.groupBox1);
			this.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.Name = "PageSetupForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Page setup";
			this.Load += new System.EventHandler(this.PageSetup_Load);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.numericSnapPixel)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void PageSetup_Load(object sender, System.EventArgs e)
		{
			//رͼƬ
			if (mainForm.myCAD1.BackgroundBitmap != null)
			{
				pictureBackgroundBitmap.Image = mainForm.myCAD1.BackgroundBitmap;
			}
			comboBackgroundBitmapMode.SelectedIndex = Convert.ToInt32(mainForm.myCAD1.BackgroundBitmapMode);
			//
			numericSnapPixel.Value = mainForm.myCAD1.SnapPixel;
			comboUnitType.SelectedIndex = Convert.ToInt32(mainForm.myCAD1.UnitType);
		}

		private void btnClear_Click(object sender, System.EventArgs e)
		{
			if (mainForm.myCAD1.BackgroundBitmap != null)
			{
				mainForm.myCAD1.BackgroundBitmap = null;
				pictureBackgroundBitmap.Image = null;
			}
		}

		private void btnLoad_Click(object sender, System.EventArgs e)
		{
			openFileDialog1.InitialDirectory = Application.ExecutablePath;
			openFileDialog1.Filter = "BMP(*.bmp)|*.bmp|JPEG(*.jpg;*.jpe;*.jpeg)|*.jpg;*.jpe;*.jpeg|All files(*.*)|*.*";
			if (openFileDialog1.ShowDialog() == DialogResult.OK)
			{
				Bitmap myBitmap = new Bitmap(openFileDialog1.FileName);
				mainForm.myCAD1.BackgroundBitmap = myBitmap;
				pictureBackgroundBitmap.Image = myBitmap;
			}
		}

		private void pictureBackgroundBitmap_Click(object sender, System.EventArgs e)
		{
			btnLoad_Click(sender,e);
		}

		private void comboBackgroundBitmapMode_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			mainForm.myCAD1.BackgroundBitmapMode = (MyBackgroundBitmapMode)comboBackgroundBitmapMode.SelectedIndex;
		}

		private void btnClose_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void numericSnapPixel_ValueChanged(object sender, System.EventArgs e)
		{
			mainForm.myCAD1.SnapPixel = Convert.ToByte(numericSnapPixel.Value);
		}

		private void comboUnitType_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			mainForm.myCAD1.UnitType = (MyUnitType)comboUnitType.SelectedIndex;
		}
	}
}
